<?php
/**
 * Copyright 2018 Kacper Donat
 *
 * @author Kacper "Kadet" Donat <kacper@kadet.net>
 *
 * Full license available in separate LICENSE file
 */

namespace Kadet\Functional\Predicate;


use Kadet\Functional\Predicate;
use function Kadet\Functional\predicate;

abstract class AbstractPredicate implements Predicate
{
    public function not(): Predicate
    {
        return new NegatedPredicate($this);
    }

    public function and(...$predicate): Predicate
    {
        array_unshift($predicate, $this);
        return new AllOfPredicate(...array_map(predicate::class, $predicate));
    }

    public function or(...$predicate): Predicate
    {
        array_unshift($predicate, $this);
        return new AnyOfPredicate(...array_map(predicate::class, $predicate));
    }
}