<?php
/**
 * Copyright 2018 Kacper Donat
 *
 * @author Kacper "Kadet" Donat <kacper@kadet.net>
 *
 * Full license available in separate LICENSE file
 */

namespace Kadet\Functional\Predicate;


class ClosurePredicate extends AbstractPredicate
{
    /**
     * @var \Closure
     */
    private $closure;

    /**
     * ClosurePredicate constructor.
     *
     * @param \Closure $closure
     */
    public function __construct(\Closure $closure)
    {
        $this->closure = $closure;
    }

    public function __invoke(...$args): bool
    {
        return ($this->closure)(...$args);
    }
}