<?php

namespace Kadet\Functional;

use Kadet\Functional\Predicate\ClosurePredicate;

/**
 * @param $predicate
 *
 * @return \Kadet\Functional\Predicate
 * @throws \Exception
 */
function predicate($predicate): Predicate
{
    if ($predicate instanceof Predicate) {
        return $predicate;
    }

    if (is_callable($predicate)) {
        return new ClosurePredicate(\Closure::fromCallable($predicate));
    }

    // todo better exception
    throw new \Exception();
}

